﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'If you change B4XMainPage then save program first and then Ctrl + click on the following to copy B4XMainPage.bas to Shared Files folder:
'			 ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\&args=..\..\Shared+Files&args=B4XMainPage.bas

Sub Class_Globals
#if B4J
	Private fx As JFX
#End If
	Private Root As B4XView
	Private xui As XUI
	Private textEngine As BCTextEngine
	Private report As BBCodeView
	Private stats As WiLStats	
	Private markTime As Long
	Private opt As WiLOptions		'used here for selecting one of the examples - is is pretty generic, but not so pretty
	Private MonoFont As B4XFont		'monospaced fonts look better for reports of matricies
	Public demo As WiLDemo			'demonstrates code examples - uses my demoPage class (see WiLDemo introduction)
	Private reportPages As List
	Private button1 As B4XView
	
	Private dMx As dMatrix			'having one global dMatrix allows simpler syntax and access to utility methods of dMatrix
	Private cMx As cMatrix			'having one global dMatrix allows simpler syntax and access to utility methods of dMatrix
	Private dComp As decomposition
	
	'You don't need to use WiLDemo at all,  dMatrix and cMatrix work fine without it 
End Sub

Public Sub Initialize
	#if B4J
		Dim monospace As Font = fx.CreateFont("Consolas", 18, False, False)
	#Else If B4A
		Dim monospace As Typeface = Typeface.CreateNew(Typeface.MONOSPACE, Typeface.STYLE_NORMAL)
	#End If
	MonoFont = xui.CreateFont(monospace, 18)
	stats.Initialize
	dComp.Initialize(Me, 5)
	reportPages.Initialize
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("2")
	dMx.Initialize(Me, "")			'dMx is Initialized to provide a module wide gateway to dMatrix methods
	cMx.Initialize(Me, "")			'cMx is Initialized to provide a module wide gateway to cMatrix methods

	textEngine.Initialize(Root)
	textEngine.KerningEnabled = False
	textEngine.CustomFonts.Put("monospace", MonoFont)
	report.TextEngine = textEngine
	demo.Initialize(Me, "B4XMainPage", True)
	B4XPages.AddPage("demo", demo)
End Sub

Sub B4XPage_Appear
	button1.visible = False
	
	Dim options() As String = Array As String("multRegression_cereals", "multRegression_fisheries", "factorAnalysis_DoleSurvey", _
	"createMatrices", "modifyShape", "modifyElements", "rowColumnFunctions", "matrixPairFunctions", "correlationCovariance", _
	"matrixUtils", "errorHandlingExample", "timing", "complexNumbers", "decompositions")
	opt.Initialize(Root, "Select an Example")
	Dim dia As Object = opt.show(options)
	Wait for (dia) complete (result As Int)
	Dim choice As String
	If result = xui.DialogResponse_Positive Then choice = opt.listTemplate.SelectedItem
	button1.visible = True
	'Code Snippet Alert - CallSub saves having a long Select sections
	Select choice
		Case "multRegression_cereals"
			multRegression("cereals", Array As Int(15, 5, 7, 9))
		Case "multRegression_fisheries"
			multRegression("fisheries", Array As Int(1, 2, 4, 5))
		Case "factorAnalysis_DoleSurvey"
			factorAnalysis("doleSurvey", Array As Int(2, 3, 4, 5, 6, 7, 8, 9, 10,11, 12, 13, 14, 15, 16, 17))
		Case "": ExitApplication
		Case Else: CallSub(Me, choice)
	End Select
End Sub

Private Sub Button1_Click
	report.Text = ""
	B4XPage_Appear	
End Sub

'Code Snippet Alert: for an explanation about how demo works look at WiLDemo class introduction
Private Sub createMatrices	'ignore
	demo.begin("Example 1.1")
	'create a dMatrix object
	'the name of the variable is passed for display and error tracking
	'set the contents to some values, here a 4x4 matrix with ones on the diagonal
	'display(n) displays the matrix with n decimal places
	
	Dim D1 As dMatrix = dMx.dIdentity("D1", 4)
	D1.display(0)
	Wait For demo_done
	
	demo.begin("Example 1.2")
	'	Dim D1 As dMatrix = dMx.dIdentity("D1", 4)
	'	D1.display(0)
	'the above 2 lines can be chained, like almost all methods in dMatrix
	
	'dIdentity is a constructor
	' Other contructors (constructor names starts with "d"):
	'	dDiagonal, dNew, dValue, dZero, dRandom, dString, dWrap, dScalar
	
	Dim D1 As dMatrix = dMx.dIdentity("D1", 4).display(0)
	Wait For demo_done

	demo.begin("Example 1.3")
	'you can create a matrix with a given shape and items loaded with a Amount
	
	Dim c77 As dMatrix = dMx.dValue("C77", 3, 5, 77)
	c77.display(0)
	
	'If the Amount is zero you can also use this
	dMx.dZero("zero", 3, 5).display(0)

	Wait For demo_done
	
	demo.begin("Example 1.4")
	'The following works but the displayed matrix does not have a reference,
	'Note that display(2) shows 2 decimal places
	
	dMx.dDiagonal("D2", 3, Array As Double(3.21, 4.7, 28.5)).display(2)
	Wait For demo_done
	
	demo.begin("Example 1.5")
	'Un-referenced dMatrix objects can't be used later
	
	'But you can put them on a list or in any other structure,
	'it is referenced, and you can use it later, even if it is nameless
	
	Dim matrices() As dMatrix = Array As dMatrix( _
		dMx.dValue("", 3, 2, 55), _
		dMx.dValue("", 2, 4, 77) _
	)
		
	matrices(0).display(0)
	matrices(1).display(0)
	Wait For demo_done
	
	demo.begin("Example 1.6")
	'the sequence of items in a dNew is repeated to fill the matrix
	'	 - in his case the items 1, 2, 3, 4 5
	
	dMx.dNew("c12345", 3, 5, Array As Double(1, 2, 3, 4, 5)).display(0)
	Wait For demo_done

	demo.begin("Example 1.7")
	'matrices can be created with smart strings (TABs and spaces are ignored)
	
	Dim matrix1 As dMatrix = dMx.dString("matrix1", $"
		19, 3, 999, 4.5
		2, 7, 0, .82	
	"$)
	matrix1.display(2)
	Wait For demo_done

	demo.begin("Example 1.8")
	'dInx is an helper function, it creates sequential 
	'numbers dInx(6, 3) and 0 to 5 offset by a Amount 3
	
	Dim mat As dMatrix = dMx.dNew("mat", 3, 2, dMx.dInx(6, 3))
	mat.display(0)
	Wait For demo_done
	
	demo.begin("Example 1.9")
	'a matrix of random numbers between -10.00 and 10.00, 2 decimal places
	
	Dim R1 As dMatrix = dMx.dRandom("R1", 6, 4, -10, 10, 2)
	R1.display(2)
	Wait For demo_done
End Sub

Private Sub modifyShape		'ignore
	demo.begin("Example 2.1")
	Dim B, D, G, G1, G2 As dMatrix
	'matrices can be appended/concatenated by row "appendR" or by column "appendC"
	
	'The naming convention for dMatrix methods is
	'	 …R = row, …C = column, …T = all elements ("T"otal)
	
	'This convention is required for compatibility with B4X syntax 
	'and it avoids having annoying and hard to read indexing syntax
	
	B = dMx.dNew("B", 2, 3, Array As Double(1, 1, 1, 2, 2, 2)).display(0)
	
	D = dMx.dNew("D", 1, 3, Array As Double(30, 30, 30)).display(0)
	
	B.appendR(D).display(0)

	G = dMx.dNew("G", 2, 1, Array As Double(10, 20)).display(0)
	
	B.appendC(G).display(0)
	Wait For demo_done
	
	demo.begin("Example 2.2")
	'all matrices, except the empty matrix, have a transpose
	
	D.display(0).transpose.display(0)
	B.display(0).transpose.display(0)
	
	B.transpose.appendC(D.transpose).display(0)
	Wait For demo_done
	
	demo.begin("Example 2.3")
	'single rows and columns can be inserted - must be one column or one row
	
	G1 = dMx.dValue("G1", 1, 3, 88).display(0)
	B.insertR(G1, 1).display(0)

	G2 = dMx.dValue("G2", 2, 1, 999).display(0)
	B.insertC(G2, 2).display(0)
	Wait For demo_done

	demo.begin("Example 2.4")
	'dot is the matrix multiplication operator 
	'(rows of 1st matrix are multiplied by columns of 2nd matrix and summed)
	
	Dim M1 As dMatrix = dMx.dNew("M1", 1, 3, Array As Double(2, 3, 4))
	Dim M2 As dMatrix = dMx.dNew("M2", 3, 2, Array As Double(5, 6, 7, 8, 9, 10))
	
	M1.display(0)
	M2.display(0)
	M1.dot(M2).display(0)
	
		'result(0,0) = M1(0,0)*M2(0,0)+M1(0,1)*M2(1,0)+M1(0,2)*M2(2,0) = 2*5+3*7+4*9 = 67
		'result(0,1) = M1(0,0)*M2(0,1)+M1(0,1)*M2(1,1)+M1(0,2)*M2(2,1) = 2*6+3*8+4*10 = 76
	Wait For demo_done
End Sub

Private Sub modifyElements	'ignore
	demo.begin("Example 3.1")
	'all elements can be modified with a Amount
	
	Dim matrix1 As dMatrix = dMx.dString("matrix1", $"
		19, 3, 999, 4.5
		2, 7, 0, .82	
	"$)
	matrix1.display(2)
	
	matrix1.timesAmount(.5).display(2)	
	matrix1.plusAmount(1000).display(2)
	Wait For demo_done
	
	demo.begin("Example 3.2")
	'individual elements of the matrix are available through its public properties
	'	 nr As Int    nc As Int     x(,) As Double
	
	matrix1.display(2)
	demo.myLog(matrix1.x(0,2), "element (0,2)")
	Wait For demo_done

	demo.begin("Example 3.3")
	'manually modify all elements	
	
	Dim matrix3 As dMatrix = matrix1.copy
	For i = 0 To matrix3.nr -1
		For j = 0 To matrix3.nc - 1
			matrix3.x(i,j) = Logarithm(matrix3.x(i,j), cE)
		Next
	Next
	
	'notice the nice B4X feature of showing -∞ for the logarithm(0)
	
	matrix3.display(5)	
	Wait For demo_done
	
	demo.begin("Example 3.4")
	'A custom function/sub can applied to all elements - a new matrix is created
	
	'	Private Sub equals(z As Double, pars() As Object) As Double
	'		Dim comparator1 As Double = pars(0)
	'		Dim comparator2 As Double = pars(1)
	'		If z = comparator1 Or z = comparator2 Then Return 1 Else Return 0
	'	End Sub
	
	Dim matrix4 As dMatrix = matrix1.display(0)
	Dim matrix5 As dMatrix = matrix4.apply("equals", Array As Object(999, 7))
	matrix5.display(0)
	Wait For demo_done
	
	demo.begin("Example 3.5")
	'The logarithm routine could be done with...
	
	'	Private Sub logN(z As Double, pars() As Object) As Double
	'		Return Logarithm(z, cE)
	'	End Sub
	
	'here there is no parameter, pars() is empty
	
	Dim logOfMatrix1 As dMatrix = matrix1.display(0)
	logOfMatrix1.apply("logN", Array As Object()).display(5)
	
	'matrix1 is unaltered
	matrix1.display(2)			
	Wait For demo_done
End Sub

Private Sub equals(z As Double, pars() As Object) As Double		'ignore
	Dim comparator1 As Double = pars(0)
	Dim comparator2 As Double = pars(1)
	If z = comparator1 Or z = comparator2 Then Return 1 Else Return 0
End Sub

Private Sub logN(z As Double, pars() As Object) As Double		'ignore
	Return Logarithm(z, cE)
End Sub

Private Sub rowColumnFunctions	'ignore
	demo.begin("Example 4.1")
	'NOTE: if the sum of rows is not meaningful, the row versions
	' of correlations and covariances are also meaningless
	
	'columns (C) and rows(R) can be summed, or overall (T)
	
	Dim matrix1 As dMatrix = dMx.dString("matrix1", $"
		1,2,3,4
		5,6,7,8
	"$).display(2)

	matrix1.sumC.display(2)
	matrix1.sumR.display(2)
	matrix1.sumT.display(2)
	Wait For demo_done
	
	demo.begin("Example 4.2")
	'other row/col operators are: mean, variance, stdDev
	
	matrix1.meanC.display(2)
	matrix1.varianceC(True).display(2)
	matrix1.stdDevC(True).display(2)
	Wait For demo_done
	
	demo.begin("Example 4.3")
	'correlation can also be done by rows or columns
	
	Dim R1 As dMatrix
	R1 = dMx.dRandom("R1", 10, 4, -10, 10, 2)
	R1.display(2).correlationC.display(3)
	Wait For demo_done
	
	demo.begin("Example 4.4")
	'it can be important to identify interdependencies in a matrix
	' - high correlations are flagged
	
	Dim col2 As dMatrix = R1.getColumn(2)
	R1.appendC(col2).display(2).correlationC.display(3)
	Wait For demo_done

End Sub

Private Sub matrixPairFunctions	'ignore
	demo.begin("Example 5.1")
	'matrices can be added, subtracted, multiplied, and divided
	'method names are plus, times, minus, divide
	
	Dim test As dMatrix = dMx.dIdentity("test", 3).display(2)
	Dim Amount As dMatrix = dMx.dValue("C9", 3, 3, 9).display(2)
	test.plus(Amount).display(0)
	test.minus(Amount).display(0)
	test.times(Amount).display(0)
	test.divide(Amount).display(2)
	Wait For demo_done

	demo.begin("Example 5.2")
	'One column/one row matrix can be correlated with another commensurate matrix
	'	 (…C # of rows are the same, …R # of columns are the same)
	
	Dim R1 As dMatrix = dMx.dRandom("R1", 10, 1, -10, 10, 2)
	R1.display(2)
	
	Dim R2 As dMatrix = dMx.dRandom("R2", 10, 4, -10, 10, 2)
	R2.display(2)
	
	R1.correlateWithC(R2).display(3)
	Wait For demo_done
End Sub

Private Sub correlationCovariance	'ignore
	demo.begin("Example 6.1")
	'it is common in Statistics to use the covariance or correlation matrix
	' formed from columns (sometimes from rows)

	Dim rand As dMatrix = dMx.dRandom("rand", 10, 4, -10, 10, 2)
	rand.display(2)
	rand.covarianceC.display(4)
	rand.correlationC.display(4)
	Wait For demo_done
	
	demo.begin("Example 6.2")
	'The formulae for variance and deviation can be for "Sample" or "Population" 
	'   Sums of deviations from means are divided by n-1 or n respectively

	'It is very rare to have data from the whole population - but
	'if you want the "Population" variance, set sample to False in the argument
	
	Dim students As dMatrix = dMx.dString("students", $"
	90,	60,	90	
	90,	90,	30
	60,	60,	60
	60,	60,	90
	30,	30,	30
	"$)

	demo.myLog("", "Sample Variance")	
	students.varianceC(True).display(4)
	
	demo.myLog("", "Population Variance")	
	students.varianceC(False).display(4)
	Wait For demo_done

	demo.begin("Example 6.3")
	
	'the stdDev is the square root of the variance, so we have to specify sample or population
	
	demo.myLog("", "Sample Standard Deviation")	
	students.stdDevC(True).display(4)
	
	demo.myLog("", "Population Standard Deviation")	
	students.stdDevC(False).display(4)
	Wait For demo_done
End Sub

Private Sub matrixUtils	'ignore
	demo.begin("Example 7.1")
	'Missing and other non-numeric values (e.g. "?") 
	'are set to NaN and are indicated in the displays by ◈
	
	Dim matrix1 As dMatrix = dMx.dString("matrix1", $"
		19, 3, 999, 4.5
		2, 7, ?, .82	
	"$).display(2)
	Wait For demo_done
	
	demo.begin("Example 7.2")
	'find the indices of a set of values
	
	matrix1.display(2)
	Dim triplets As List = matrix1.find(Array As Double(999, 7, "NaN"))
	
	'create log
	
	Dim sb As StringBuilder: sb.initialize
	For Each v() As Double In triplets
		Dim i As Int = v(0)
		Dim j As Int = v(1)
		sb.Append(v(2) & " at " & i & ", " & j & CRLF)
	Next
	demo.myLog(sb.ToString, "found value at row, col")
	Wait For demo_done
	
	demo.begin("Example 7.3")
	'test samesness (shape and elements, within a tolerance)
	' - separate objects or the same object
	
	Dim matrix2 As dMatrix = matrix1.copy
	matrix2.display(2)	
	matrix1.display(0)
	Dim almost As Boolean = matrix1.withinEps(matrix2.display(0), .000000001)
	demo.myLog(almost, " they are within tolerance")
	Wait For demo_done
	
	demo.begin("Example 7.4")
	matrix2.x(0, 2) = -1
	matrix1.display(0)
	Dim almost As Boolean = matrix1.withinEps(matrix2.display(0), .000000001)
	demo.myLog(almost, " one element differs and withinEps is")
	Wait For demo_done
	
	demo.begin("Example 7.5")
	'sort rows by one specific column, ascending or descending
	
	Dim R2 As dMatrix
	R2 = dMx.dRandom("R2", 10, 4, -10, 10, 2).display(2)
	R2.sortC(2, True).display(2)
	Wait For demo_done
	
	demo.begin("Example 7.6")
	'sort columns by one specific row, ascending or descending
	
	Dim R3 As dMatrix
	R3 = dMx.dRandom("R3", 10, 4, -10, 10, 2).display(2)
	R3.sortR(7, False).display(2)
	Wait For demo_done
	
	demo.begin("Example 7.7")
	'rank of matrix - number of independent rows/colums,
	'here the last row is 3*(Row 0) + 2*(Row 1)
	
	Dim matrix3 As dMatrix = dMx.dString("matrix3", $"
		0,	1,	2	
		1,	2,	1
		2,	7,	8
	"$)
	
	matrix3.display(0)
	demo.myLog("Rank is " & matrix3.rank, "")
	Wait For demo_done
	
	demo.begin("Example 7.8")
	'Vectorize matrices - vectors are one dimensional Arrays

	Dim matrix4 As dMatrix
	matrix4 = dMx.dNew("matrix4", 4, 3, Array As Double(1, 2, 3)).display(0)
	
	demo.myLog(demo.vectorToString(matrix4.toVectorC, 0), matrix4.id & " as vector, by columns")
	demo.myLog(demo.vectorToString(matrix4.toVectorR, 0), matrix4.id & " as vector, by rows")
	Wait For demo_done
End Sub

Private Sub errorHandlingExample		'ignore
	'The following is an illegal dMatrix operation 
	'An error message displays the dMatrix Sub where error occured and id of matrix involved - execution is stopped
	'	that is why we can't use the demo class for demonstrating this effect
	
	Dim m1 As dMatrix = dMx.dValue("m1", 1, 1, 1)
	Dim m2 As dMatrix = dMx.dValue("m2", 2, 2, 2)
	m1.dot(m2)
End Sub

Private Sub timing	'ignore
	Dim A As dMatrix = dMx.dRandom("A", 10, 10, -10, 10, 2)
	A.display(2)
	Dim inverse As dMatrix
	markTime = DateTime.Now
	For i = 1 To 10000
		inverse = A.inverse
		If i Mod 1000 = 0 Then 
			Log("Time taken: " & (DateTime.Now - markTime))
			markTime = DateTime.Now
		End If
	Next
	Log(TAB)
	Log("Each number of msecs represent 1000 matrix inverses!")
	Log("First run is longer due to Just In Time compilation and lazy loading of classes")
	
	Log(TAB)
	inverse.rename("AInverse")
	inverse.display(3)
	A.dot(inverse).display(3)

'on my setup, release mode: Intel i7-4700 at 3.6 GHz	B4J version 8.50 Windows 10.0
'Time taken: 86
'Time taken: 73
'Time taken: 69
'Time taken: 80
'Time taken: 79
'Time taken: 70
'Time taken: 44
'Time taken: 37
'Time taken: 37
'Time taken: 41

'Aside: On my first try, I timed Multiple Linear Regression, but except for the first set, all timed values were zero.
'		I was seeing the benefit of B4XPages which only needed to calculate everything once.

'B4A - release mode - ARM Cortex 1.8 GHz B4A version 10.2 Samsung Tab 10 S2 - Android 7.0
'Time taken: 1035
'Time taken: 976
'Time taken: 980
'Time taken: 981
'Time taken: 983
'Time taken: 986
'Time taken: 989
'Time taken: 1012
'Time taken: 994
'Time taken: 1000

'Execution on Tablet was about 25x slower than on desktop,
' but still only about 1 millisecond per inversion  (1000 per 1000msec)

End Sub

Private Sub complexNumbers	'ignore
	demo.begin("Example 8.1")
	'Complex numbers are implemented in the cMatrix class as paired, 
	'    synchronized double precision matrices, with the same shape
	
	'It uses the methods of dMatrix extensively, its gateway object is:
	'			 Private cMx As cMatrix
	'(Look at dMatrix examples before going through the complexNumbers example)
	
	'create a cMatrix object, when dMatrix has one parameter, cMatrix has two
	
	Dim Z As cMatrix = cMx.cDiagonal("Z", 3, 1, 0)  '3x3, real part=1, complex part=0
	Z.display(0)

	Dim c1 As cMatrix = cMx.cNew("C1", 3, 5, Array As Double(1, 2, 3, 4, 5), Array As Double(.05))
	c1.display(2)
	Wait For demo_done

	demo.begin("Example 8.2")
	'Public properties of cMatrix are: id, nr, nc, dMx_R, dMx_I
	Dim c1 As cMatrix = cMx.cRandom("c1", 3, 2, -10, 10, -10, 10, 2)
	c1.display(2)
	
	demo.myLog("      " & c1.id & "   " & c1.nr & "   " & c1.nc, "id   nr   nc")
	c1.dMx_R.display(2)
	c1.dMx_I.display(2)
	Wait For demo_done
	
	demo.begin("Example 8.3")
	'transpose
	Dim c1 As cMatrix = cMx.cRandom("c1", 3, 2, -10, 10, -10, 10, 2)
	c1.display(2)

	c1.transpose.display(2)	
	Wait For demo_done
	
	demo.begin("Example 8.4")
	'adding complex numbers
	Dim c1 As cMatrix = cMx.cRandom("c1", 3, 2, -10, 10, -10, 10, 2)
	c1.display(2)

	Dim c2 As cMatrix = cMx.cRandom("c2", 3, 2, -10, 10, -10, 10, 2)
	c2.display(2)
	
	c1.plus(c2).display(2)
	Wait For demo_done
	
	demo.begin("Example 8.5")
	'multiplying complex numbers
	Dim c1 As cMatrix = cMx.cRandom("c1", 3, 2, -10, 10, -10, 10, 2)
	c1.display(2)

	Dim c2 As cMatrix = cMx.cRandom("c2", 3, 2, -10, 10, -10, 10, 2)
	c2.display(2)
	
	c1.times(c2).display(2)
	Wait For demo_done

	demo.begin("Example 8.6")
	'dividing complex numbers
	Dim c1 As cMatrix = cMx.cRandom("c1", 3, 2, -10, 10, -10, 10, 2)
	c1.display(2)

	Dim c2 As cMatrix = cMx.cRandom("c2", 3, 2, -10, 10, -10, 10, 2)
	c2.display(2)
	
	c1.divide(c2).display(2)
	Wait For demo_done

	demo.begin("Example 8.7")
	'squared
	Dim c1 As cMatrix = cMx.cRandom("c1", 3, 2, -10, 10, -10, 10, 2)
	c1.display(2)

	c1.squared.display(2)
	Wait For demo_done

	demo.begin("Example 8.8")
	'phase - this is not relevant for non-complex matrices
	Dim c1 As cMatrix = cMx.cRandom("c1", 3, 2, -10, 10, -10, 10, 2)
	c1.display(2)

	c1.phase.display(4)
	Wait For demo_done

	demo.begin("Example 8.9")
	'absValue - this has a different meaning than in non-complex matrices
	Dim c1 As cMatrix = cMx.cRandom("c1", 3, 2, -10, 10, -10, 10, 2)
	c1.display(2)

	c1.absValue.display(2)
	Wait For demo_done

	demo.begin("Example 8.10")
	'conjugate - this is not relevant for non-complex matrices, dMx_I is negated
	Dim c1 As cMatrix = cMx.cRandom("c1", 3, 2, -10, 10, -10, 10, 2)
	c1.display(2)

	c1.conjugate.display(2)
	Wait For demo_done

	demo.begin("Example 8.11")
	'reciprocal - this requires a separate method in complex numbers
	Dim c1 As cMatrix = cMx.cRandom("c1", 3, 2, -10, 10, -10, 10, 2)
	c1.display(2)

	c1.reciprocal.display(2)
	Wait For demo_done
End Sub

Private Sub decompositions			'ignore
	demo.begin("Example 9.1")

	Dim A As dMatrix = dMx.dString("A", $"
		2, -4, -1, 9
		-3, 2, -5, 2
		4, 3, -1, -7
	"$).display(0)
	
	'QR decomposition
	Dim QRresults() As dMatrix = dComp.QR(A)
	Dim Q As dMatrix = QRresults(0)
	Dim R As dMatrix = QRresults(1)
	Q.display(3)
	R.display(3)
	Wait For demo_done
	
	demo.begin("Example 9.2")
	'Q is orthogonal: Q.transpose.dot(Q) is identity matrix
	Dim Qt As dMatrix = Q.transpose.rename("Qt")
	Qt.dot(Q).display(3)
	Wait For demo_done
 
	demo.begin("Example 9.3")
	' A = Q.dot(R)		the definition of QR decomposition
	A.display(0)
	Q.dot(R).display(3)
	Wait For demo_done
	
	demo.begin("Example 9.4")
	'Eigen decomposition
	Dim E As dMatrix = dMx.dString("E", $"
		1, 2, 4
		2, 5, 2
		4, 2, 1
	"$).display(0)
	Dim EigenResults() As dMatrix = dComp.eigenSymmetric(E)
	Dim vectors As dMatrix = EigenResults(0)
	Dim values As dMatrix = EigenResults(1)
	vectors.display(3)
	values.display(3)
	Wait For demo_done
	
	demo.begin("Example 9.5")
	'E = vector.values.(vectors.transpose) columns reorderd: definition of eigen objects
	E.display(3)
	Dim Vt As dMatrix = vectors.transpose.rename("Vt")
	vectors.dot(values).dot(Vt).display(3)
	Wait For demo_done
	
	demo.begin("Example 9.6")
	'SVDecomposition when # rows <=  # cols
	A.display(3)
	Dim SVDresults() As dMatrix = dComp.SVD(A)
	Dim U As dMatrix = SVDresults(0)
	Dim S As dMatrix = SVDresults(1)
	Dim V As dMatrix = SVDresults(2)
	U.display(3)
	S.display(3)
	V.display(3)
	Wait For demo_done
	
	demo.begin("Example 9.7")
	'U.S.Vt = original A
	A.display(3)
	Dim Vt As dMatrix = vectors.transpose.rename("Vt")
	U.dot(S).dot(Vt).display(3)
	Wait For demo_done

	demo.begin("Example 9.8")
	'SVD decomposition when # rows > # cols
	Dim B As dMatrix = A.transpose.rename("B").display(3)
	Dim SVDresults() As dMatrix = dComp.SVD(B)
	Dim U As dMatrix = SVDresults(0)
	Dim S As dMatrix = SVDresults(1)
	Dim V As dMatrix = SVDresults(2)
	U.display(3)
	S.display(3)
	V.display(3)
	Wait For demo_done

	demo.begin("Example 9.9")
	'U.S.Vt = original B
	B.display(3)
	U.dot(S).dot(V.transpose).display(3)
	Wait For demo_done

	demo.begin("Example 9.10")
	'SchurDecomposition
	Dim E As dMatrix = dMx.dString("E", $"
		3, 2, 1
		4, 2, 1
		4, 4, 0
	"$).display(0)
	Dim SchurResults() As dMatrix = dComp.Schur(E)
	Dim Q As dMatrix = SchurResults(0)
	Dim T As dMatrix = SchurResults(1)
	Q.display(3)
	T.display(3)
	Dim Qt As dMatrix = Q.transpose.rename("Qt")
	Q.dot(T).dot(Qt).display(3)
	Wait For demo_done
End Sub

'The text file is TAB delimited, the indices are column numbers for y, x1, x2, x3, etc. for the model
Private Sub multRegression(repName As String, indices() As Int)			'ignore
	'On first view read and prepare data, and initialize B4XPage 
	If reportPages.IndexOf(repName) = -1 Then 
		Dim dataset As List = File.ReadList(File.DirAssets, repName & ".txt")
		Dim vinx() As Int = indices

		'the first row of the file are headers
		Dim ncases As Int = dataset.Size - 1
		Dim vars() As String = Regex.Split(TAB, dataset.Get(0))

		'start with a zero array of the right size, then fill it with data points
		Dim data As dMatrix = dMx.dValue("data", ncases, vinx.length, 0)
		Dim names(vinx.Length) As String
		For i = 0 To ncases - 1
			Dim v() As String = Regex.Split(TAB, dataset.Get(i+1))
			For j = 0 To vinx.Length - 1
				data.x(i, j) = v(vinx(j))
				If i = 0 Then names(j) = vars(vinx(j))
			Next
		Next
		
		Dim rep As WiLMultRegression
		rep.Initialize(Me, data, names)
		B4XPages.AddPage(repName, rep)
		reportPages.add(repName)
	End If
	B4XPages.ShowPage(repName)
End Sub

'The text file is comma delimited, the indices are column numbers for y, x1, x2, x3, etc. for the model
Sub factorAnalysis(repName As String, indices() As Int)
	'On first view read and prepare data, and initialize B4XPage 
	If reportPages.IndexOf(repName) = -1 Then 
		Dim dataset As List = File.ReadList(File.DirAssets, repName & ".txt")

		'the first section of the file is the dictionary
		Private dictionary As Map: dictionary.initialize
		Dim dataStart As Int = -1
		For i = 0 To dataset.Size - 1
			Dim s As String = dataset.Get(i)
			If s.StartsWith("_") Then 
				dataStart = i + 1
				Exit		
			End If
			Dim v() As String = twoParts(s, ":")
			dictionary.Put(v(0), v(1))
		Next
		Dim sb As StringBuilder: sb.Initialize
		For i = dataStart To dataset.Size - 1
			sb.Append(dataset.get(i)).Append(CRLF)
		Next
		Dim rawA As dMatrix = dMx.dString("rawA", sb.toString)
		Dim temp As dMatrix = rawA.getSubset(dMx.iInx(rawA.nr, 0), indices)
		Dim data As dMatrix = temp.apply("setMissing", Array As Object(8))	'non-numeric entries are automatically set to missing (NaN).rename("data")
	
		Dim rep As WiLPCAFactor
		rep.Initialize(Me, data, dictionary)
		B4XPages.AddPage(repName, rep)
		reportPages.add(repName)
	End If
	B4XPages.ShowPage(repName)
End Sub 

'Used by "factorAnalysis" for setting dataset dependent missing values
Private Sub setMissing(z As Double, pars() As Object) As Double		'ignore
	For Each dd As Object In pars
		Dim d As Double = dd
		If z = d Then 
			z = "NaN"
			Exit
		End If
	Next
	Return z
End Sub

'A utility I use frequently to split a string into two parts - here used by "factorAnalysis"
Sub twoParts(s As String, c As String) As String()
	Dim r(2) As String
	r(0) = s
	r(1) = ""
	Dim k As Int = s.IndexOf(c)
	If k > -1 Then
		r(0) = s.SubString2(0, k)
		r(1) = s.SubString(k + c.Length)
	End If
	Return r
End Sub

'Called from dMatrix as output from "errorMessage(s)" in dMatrix and cMatrix
Private Sub matrixErrors(s As String)
	demo.matrixErrors(s)					'replace this with project dependent code
End Sub

'Called from dMatrix as output of "display(n)" in dMatrix and cMatrix
Private Sub myLog(s As String, info As String)
	demo.myLog(s, info)						'replace this with project dependent code
End Sub

