﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
'Introduction:

'I found myself frequently writing the same code to perform a simple function - choose among a set of of options presented in a list
'This class simplifies that task greatly, at the cost of assigning my own preferences to the parameters of the B4XPreferencesDialog

'It is still cross-platform, but not pretty in the eye of some beholders
'The show method takes an array of strings and returns a dialog object that the calling program can Wait For

'I found that sometimes, especially in Android, the scroll view has more content that I didn't notice, so I added a subtle alert for that

Sub Class_Globals
	Private xui As XUI
	Public isEnabled As Boolean
	Public isInitialized As Boolean 
	
	Private dialog As B4XDialog
	Public listTemplate As B4XListTemplate
	
	Private more As Label
	Private bMore As B4XView
End Sub

Public Sub Initialize(target As B4XView, title As String)
	dialog.Initialize(target)
	dialog.OverlayColor = xui.Color_ARGB(100, 255, 255, 255)
	dialog.BackgroundColor = xui.Color_White
	dialog.BorderColor = xui.Color_Black
	dialog.BorderWidth = 1
	dialog.BorderCornersRadius = 5dip
	
	dialog.Title = title
	dialog.TitleBarFont = xui.CreateDefaultBoldFont(18)
	dialog.TitleBarHeight = 40dip
	dialog.TitleBarColor = 0xFF8888FF

	dialog.ButtonsColor = xui.color_RGB(200, 200, 255)
	dialog.ButtonsTextColor = xui.Color_White
	
	listTemplate.Initialize
	listTemplate.CustomListView1.DefaultTextBackgroundColor = xui.Color_White
	listTemplate.CustomListView1.DefaultTextColor = xui.Color_Black
	listTemplate.CustomListView1.AsView.SetColorAndBorder(xui.Color_White, 0, 0, 0)
	listTemplate.Resize(400dip, 300dip)

#if B4J
	listTemplate.CustomListView1.DesignerLabel.Style = ""
#else if B4A

#End If
	Dim dlbl As B4XView = listTemplate.CustomListView1.DesignerLabel
	dlbl.Font = xui.CreateDefaultBoldFont(18)	
	more.Initialize("")
	Dim bMore As B4XView = more
	bMore.SetTextAlignment("CENTER", "LEFT")
	bMore.Text = "Scroll for More"
	bMore.TextSize = 18
	Dim bold As B4XFont = xui.CreateDefaultBoldFont(18)
	bMore.Font = bold
	bMore.TextColor = xui.Color_White
End Sub

'options are an Array of string, result is a dialog object that can be waited for
Public Sub show(options() As String) As Object
	Dim scrollCol As Int = xui.Color_White
	#if b4J
		Dim sv As ScrollPane = listTemplate.CustomListView1.sv
		sv.SetVScrollVisibility("NEVER")
	#End If

	If options.Length > 5 Then 
		scrollCol = xui.Color_LightGray
	#if b4J
		Dim sv As ScrollPane = listTemplate.CustomListView1.sv
		sv.SetVScrollVisibility("ALWAYS")
	#End If
	End If
	listTemplate.CustomListView1.sv.ScrollViewInnerPanel.color = scrollCol
	listTemplate.Options = options
	Dim dia As Object = dialog.ShowTemplate(listTemplate, "", "", "Cancel")
	listTemplate.CustomListView1.getBase.Width = 400dip
	Dim availableSpace As Float = listTemplate.CustomListView1.AsView.Height
	Dim overflow As Boolean = False
	For i = 0 To options.length - 1
		listTemplate.CustomListView1.ResizeItem(i, 46dip)
		Dim container As CLVItem = listTemplate.CustomListView1.GetRawListItem(i)
		Dim pnl As B4XView = container.Panel
		Dim pnlChild As B4XView = pnl.GetView(0)
		Dim lbl As B4XView = pnlChild.GetView(0)
		lbl.SetTextAlignment("CENTER", "LEFT")
		lbl.TextColor =  xui.color_Blue
		pnl.SetLayoutAnimated(0, 0, container.Offset-2, 370dip, 50dip)
		If pnl.top + 50dip > availableSpace Then overflow = True
	Next
	Dim dPanel As B4XView = dialog.Base					'This is done here after dialog.Base is initialized
	dPanel.Color = xui.color_RGB(200, 200, 255)
	If overflow Then 
		dPanel.AddView(more, .35 * dPanel.Width, .89 * dPanel.Height, .33 * dPanel.Width, .1 * dPanel.Height)	
	End If
	Dim availableSpace As Float = listTemplate.CustomListView1.AsView.Height
	Return dia
End Sub


